#include <smlib>

#if defined _smlib_general_included
  #endinput
#endif
#define _smlib_general_included

stock AddPathToDownloads(String:path[]) {

	if (FileExists(path)) {
		
		new String:fileExtension[4];
		
		GetFileExtension(path,fileExtension,sizeof(fileExtension));
		
		new bool:addDownload = false;
		
		if (!StrEqual(fileExtension, "bz2", false) && !StrEqual(fileExtension, "ztmp", false)) {
			addDownload = true;
		}
		
		if (addDownload) {
			AddFileToDownloadsTable(path);
		}
	}
	
	if (DirExists(path)) {
		decl String:entry[256];
		decl String:newpath[PLATFORM_MAX_PATH];
		new Handle:dir = OpenDirectory(path);
		
		while (ReadDirEntry(dir, entry, sizeof(entry))) {
			if (StrEqual(entry, ".") || StrEqual(entry, "..")) {
				continue;
			}
			
			Format(newpath, sizeof(newpath), "%s/%s", path, entry);
			AddPathToDownloads(newpath);
		}
		
		CloseHandle(dir);
	}
	
	return;
}
/**
 * Gets the filename only out of a path.
 *
 * @param path				Input string path or filename.
 * @param filename			Output filename.
 * @param maxlenName		Max length of filename buffer.
 * @noreturn
 */
stock bool:GetFileName(String:path[], pathMaxlen,String:filename[], maxlenName){
	
	if(path[0] == '\0'){
		return false;
	}
	
	new extpos = FindCharInString(path, '.', true);
	
	if(StrEqual(path[extpos],"",false)){
		return false;
	}
	
	ReplaceString(path, pathMaxlen, path[extpos], "", false);
	
	new filenamestartpos = FindCharInString(path, '/', true);
	
	strcopy(filename, maxlenName, path[filenamestartpos+1]);
	
	return false;
}

/**
 * Gets the Extension out of a filename or path.
 *
 * @param path_or_file		Input string path or filename.
 * @param extension			Output string only the last extension example: /sourcemod/extensions/example.ext.so will return 'so'.
 * @param maxlenExt			Max length of extension buffer.
 * @noreturn
 */
stock GetFileExtension(String:path_or_file[],String:extension[],maxlenExt){
	
	new extpos = FindCharInString(path_or_file, '.', true);
	
	if (extpos == -1) {
		
		return;
	}
	
	extpos++;
	
	if(!StrEqual(path_or_file[extpos],"",false)) {
		
		strcopy(extension,maxlenExt,path_or_file[extpos]);
	}
}

/**
 * Downloads all files/paths within the given .txt file.
 *
 * @param path				Path to the .txt file.
 * @noreturn
 */
stock ExternalDownloadsFile(const String:path[]){
	//Download file materials/skins etc... jetzt extern in download.txt :)
	new Handle:filex = OpenFile(path, "r");
	
	if (filex != INVALID_HANDLE) {
		new String:buffer[256];
		while (!IsEndOfFile(filex)) {
			
			ReadFileLine(filex, buffer, sizeof(buffer));
			TrimString(buffer);
			
			if (StrEqual(buffer, "")) {
				continue;
			}
			
			if (StrContains((buffer), ".bz2", false) != -1){
				continue;
			}
			
			if (StrContains((buffer), ".ztmp", false) != -1){
				continue;
			}
			
			if (StrContains((buffer), "//", false) == 0){
				continue;
			}
			AddPathToDownloads(buffer);
		}
		CloseHandle(filex);
	}
}

stock GetServerPort(String:port[], maxlen){
	
    new Handle:cv_port = FindConVar("port");

    if(cv_port != INVALID_HANDLE){
		
        GetConVarString(cv_port, port, maxlen);
        CloseHandle(cv_port);
    }
}

stock GetServerHostname(String:hostname[], maxlen){
	
    new Handle:cv_hostname = FindConVar("hostname");

    if(cv_hostname != INVALID_HANDLE){
		
        GetConVarString(cv_hostname, hostname, maxlen);
        CloseHandle(cv_hostname);
    }
}

