#include <smlib>

#if defined _smlib_strings_included
  #endinput
#endif
#define _smlib_strings_included

/**
 * Checks if the string is nummeric.
 *
 * @param str				String to check.
 * @return					True if its nummeric otherwise false.
 */
stock String_IsNumeric(String:str[]) {
	
	new n = 0;
	
	while (str[n] == ' ') {
		n++;
	}
	
	if (str[n] == '-' || str[n] == '+') {
		n++;
	}
	
	while (str[n] == ' ') {
		n++;
	}

	while (str[n] != '\0') {
		
		if (!IsCharNumeric(str[n])) {
			return false;
		}
		
		n++;
	}
	
	return true;
}


/**
 * Trims a string by removing chars from beginning and ending.
 *
 * @param buffer				Input/output string.
 * @param maxlen				Max size of the buffer string.
 * @param char					The char which should be removed
 * @noreturn
 */
stock String_TrimChar(String:buffer[],maxlen,char){
	
	new x=0;
	
	while(buffer[x] == char){
		
		x++;
	}
	
	
	new y=strlen(buffer)-1;
	
	while(buffer[y] == char){
		
		y--;
	}
	
	buffer[y+1] = '\0';
	
	strcopy(buffer,maxlen,buffer[x]);
}

/**
 * Wraps a string in chars, means adds a char to the begin and a char the end.
 *
 * @param buffer				Input/output string.
 * @param maxlen				Max size of the buffer string.
 * @param char					The char which should be added to the beginning and to the end.
 * @noreturn
 */
stock String_WrapString(String:buffer[],maxlen,String:str[]){
	
	new String:subbuffer[maxlen];
	
	strcopy(subbuffer,maxlen,str);
	StrCat(subbuffer,maxlen,buffer);
	StrCat(subbuffer,maxlen,str);
	
	strcopy(buffer,maxlen,subbuffer);
}


/**
 * .Removes a list of strings from a string.
 *
 * @param buffer			Input/Ourput buffer.
 * @param maxlen			Max size of buffer.
 * @param removeList		A list of strings which should be removed from buffer.
 * @param size				Size of list.
 * @noreturn
 */
stock String_RemoveList(String:buffer[],maxlen,String:removeList[][],size){
	
	
	for(new i=0;i<size;i++){
		
		ReplaceString(buffer, maxlen, removeList[i], "", false);
	}
}

/**
 * Lowers every char of a string.
 *
 * @param buffer			Input/Ourput text.
 * @param maxlen			Max size of text.
 * @noreturn
 */
stock String_Lower(String:text[],maxlen){
	
	for(new i=0;i<maxlen;i++){
		
		if(IsCharLower(text[i])){
			continue;
		}
		
		text[i] = CharToLower(text[i]);
	}
}