#include <smlib>

#if defined _smlib_teams_included
  #endinput
#endif
#define _smlib_teams_included

/*****************************************************************


 T E A M   D E F I N E S


*****************************************************************/
#define TEAM_UNASSIGNED 0
#define TEAM_SPECTATOR 1
#define TEAM_BLUE 2
#define TEAM_RED 3

/*****************************************************************


 T E A M   F U N C T I O N S


*****************************************************************/
/*
 * If one team is empty its assumed single team mode is enabled.
 *
 * @noparam
 * @return			True if one team is empty, false otherwise.			
 */
stock bool:Team_SingleMode(){
	
	new countRed = 0;
	new countBlue = 0;
	new clientTeam = -1;
	
	for(new client=1;client<=MaxClients;client++){
		
		if(!IsClientInGame(client) || !IsPlayerAlive(client)){
			continue;
		}
		
		clientTeam = GetClientTeam(client);
		
		if(clientTeam == 2){
			
			countRed++;
		}
		else if(clientTeam == 3){
			
			countBlue++;
		}
	}
	
	if(countRed == 0 || countBlue == 0){
		return true;
	}
	
	return false;
}
/*
 * Counts players in the given team.
 *
 * @param			Team index TEAM_UNASSIGNED = 0, TEAM_SPECTATOR = 1, TEAM_BLUE = 2, TEAM_RED = 3.
 * @return			Number of players in the given team.
 */
stock Team_CountPlayers(team){
	
	new count = 0;
	
	for(new client=1;client<=MaxClients;client++){
		
		if(!IsClientInGame(client) || !IsPlayerAlive(client)){
			continue;
		}
		
		if(GetClientTeam(client) == team){
			
			count++;
		}
	}
	
	return count;
}